Subject: schedule_timeout sleeps too long after dividing CPU frequency

From: [email-masked] (Mason)
Date: Fri, 15 May 2015 15:58:23 +0200

[ Dropping cpufreq and linux-pm ]

On 15/05/2015 15:15, Russell King - ARM Linux wrote:

> I guess I was wrong.  I'm no expert on the kernel's time code.  That's
> why I've suggested to you several times that you do the research
> yourself, rather than me having to do that research for you and then
> write an email about it.  It's kind of wasting my time, and you're not
> paying me for this kind of support service...

Sorry if my questions appeared to be asking you to do
my research for me. I was hoping some of the ARM guys
might eventually chime in, as they wrote most of the
TWD code.

Anyway, thanks to you and Viresh for pointing out the
most likely culprit for my problem. I'll take a hard
look at clockevents source code next week.

> What I'm saying is that I have a platform here running a modern kernel
> which _does_ use the TWD, and it _does_ appear to be running in high-res
> mode.

Thanks for providing evidence that it does work. I am
now hopeful to get it working. I'll start by applying
my patch to a more recent kernel.

For the record, if I remove the CLOCK_EVT_FEAT_C3STOP
flag, then the system does provide hrtimers, but this
seems to be a red herring.

Regards.